//########## Blimp

//### Sound

datablock AudioProfile(gc_BlimpEngineSound)
{
  filename = "./propel.wav";
  description = AudioDefaultLooping3d;
  preload = true;
};

//### Effects

datablock ParticleData(gc_vehicleDamageParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = -2;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0 0 0 0";
  colors[1] = "0 0 0 0.5";
  colors[2] = "0 0 0 0";
  sizes[0] = 3;
  sizes[1] = 4;
  sizes[2] = 6;
  times[0] = 0;
  times[1] = 0.2;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_vehicleDamageEmitter)
{
  uiName = "";
  ejectionPeriodMS = 50;
  periodVarianceMS = 25;
  ejectionVelocity = 2;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_vehicleDamageParticle";
  useEmitterColors = true;
};

datablock ParticleData(gc_BlimpTrailParticle)
{
  dragCoefficient = 1;
  gravityCoefficient = 0;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 2000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0.8 0.8 0.8 0";
  colors[1] = "0.8 0.8 0.8 0.1";
  colors[2] = "0.8 0.8 0.8 0";
  sizes[0] = 3;
  sizes[1] = 1.5;
  sizes[2] = 3;
  times[0] = 0;
  times[1] = 0.2;
  times[2] = 1;
  useInvAlpha = true;
  windCoefficient = 1;
};

datablock ParticleEmitterData(gc_BlimpTrailEmitter)
{
  uiName = "";
  ejectionPeriodMS = 20;
  periodVarianceMS = 0;
  ejectionVelocity = 5;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 10;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_BlimpTrailParticle";
};

datablock ShapeBaseImageData(gc_BlimpTrail7Image)
{
  shapeFile = "base/data/shapes/empty.dts";
  emap = false;
  mountPoint = 7;

  stateName[0] = "Trail";
  stateTransitionOnTimeout[0] = "Trail";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 1;
  stateEmitter[0] = gc_BlimpTrailEmitter;
  stateEmitterTime[0] = 1;
};

datablock ShapeBaseImageData(gc_BlimpTrail8Image)
{
  shapeFile = "base/data/shapes/empty.dts";
  emap = false;
  mountPoint = 8;

  stateName[0] = "Trail";
  stateTransitionOnTimeout[0] = "Trail";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 1;
  stateEmitter[0] = gc_BlimpTrailEmitter;
  stateEmitterTime[0] = 1;
};

//### Vehicle

datablock FlyingVehicleData(gc_BlimpVehicle)
{
  uiName = "Blimp";
  category = "Vehicles";
  displayName = "";
  shapeFile = "./blimp.dts";
  emap = true;
  minMountDist = 7;
  numMountPoints = 7;
  mountThread[0] = "root";
  mountThread[1] = "root";
  mountThread[2] = "root";
  mountThread[3] = "root";
  mountThread[4] = "root";
  mountThread[5] = "root";
  mountThread[6] = "root";
  mass = 400;
  maxDamage = 200;
  destroyedLevel = 200;
  speedDamageScale = 1.04;
  collDamageThresholdVel = 20;
  collDamageMultiplier = 0.02;
  lookUpLimit = 0.8;
  lookDownLimit = 0.2;
  jetForce = 500;
  jetEnergyDrain = 8;
  minJetEnergy = 1;
  massCenter = "0 0 0";
  density = 5;
  drag = 1.6;
  bodyFriction = 0.6;
  bodyRestitution = 0.6;
  minImpactSpeed = 5;
  softImpactSpeed = 25;
  hardImpactSpeed = 50;
  minRollSpeed = 0;
  maxSteeringAngle = 0.785;
  maxDrag = 40;
  minDrag = 50;
  integration = 4;
  collisionTol = 0.1;
  contactTol = 0.001;
  cameraRoll = false;
  cameraMaxDist = 20;
  cameraLag = 5;
  cameraDecay = 0;
  cameraOffset = 5;
  cameraTilt = 0;
  triggerDustHeight = 3;
  dustHeight = 6;
  damageEmitter[0] = gc_vehicleDamageEmitter;
  damageEmitterOffset[0] = "0 -5 2";
  damageLevelTolerance[0] = 0.5;
  damageEmitter[1] = VehicleBurnEmitter;
  damageEmitterOffset[1] = "0 -5 2";
  damageLevelTolerance[1] = 0.9;
  numDmgEmitterAreas = 1;
  splashFreqMod = 300;
  splashVelEpsilon = 0.5;
  exitSplashSoundVelocity = 2;
  softSplashSoundVelocity = 1;
  mediumSplashSoundVelocity = 2;
  hardSplashSoundVelocity = 3;
  rideable = true;
  paintable = true;
  maneuveringForce = 2000;
  horizontalSurfaceForce = 10;
  verticalSurfaceForce = 100;
  autoInputDamping = 0.95;
  steeringForce = 2000;
  steeringRollForce = 0;
  rollForce = 400;
  autoAngularForce = 6000;
  rotationalDrag = 25;
  autoLinearForce = 100;
  maxAutoSpeed = 15;
  hoverHeight = 2;
  createHoverHeight = 2;
  minTrailSpeed = 1;
  vertThrustMultiple = 1;
  initialExplosionProjectile = vehicleExplosionProjectile;
  initialExplosionOffset = 0;
  burnTime = 5000;
  finalExplosionProjectile = vehicleFinalExplosionProjectile;
  finalExplosionOffset = 0.5;
  minRunOverSpeed = 5;
  runOverDamageScale = 5;
  runOverPushScale = 1.2;
  protectPassengersBurn = false;
  protectPassengersRadius = false;
  protectPassengersDirect = true;
  heightcontrol = 1;
  ascendVelocity = 0.5;
  descendVelocity = -0.5;
};

function gc_BlimpVehicle::onadd(%this,%obj)
{
  %obj.playThread(0,"root");
  %obj.PlayAudio(0,gc_BlimpEngineSound);
  %obj.mountImage(gc_BlimpTrail7Image,0);
  %obj.mountImage(gc_BlimpTrail8Image,1);
}

function gc_BlimpVehicle::onImpact(%this,%obj,%col,%pos,%speed1)
{
  %speed2 = vectorLen(%obj.getVelocity());
  %obj.damage(%obj,%obj.getPosition(),%speed);
  if(%obj.destroyed) return;
  if(%speed1 > 20 || %speed2 > 20)
  {
    %p = new Projectile()
    {
      dataBlock = vehicleExplosionProjectile;
      initialVelocity = 0;
      initialPosition = %obj.getTransform();
      sourceObject = %obj;
      client = %obj.client;
    };
    MissionCleanup.add(%p);
    %obj.setDamageLevel(%this.maxDamage);
    %obj.destroyed = 1;
    %obj.schedule(10,"finalExplosion");
    %respawn = %obj.spawnBrick.client.minigame.vehicleReSpawnTime;
    %obj.spawnBrick.schedule(%respawn,"spawnVehicle");
  }
}

if($Addon__Weapon_FlintlockWeapons $= 1)
{
  ForceRequiredAddOn("Weapon_FlintlockWeapons");
  exec("./blimpfl.cs");
}
