//########## Blimp versions that have the Flintlock turrets mounted

datablock FlyingVehicleData(gc_BlimpScorpioVehicle : gc_BlimpVehicle)
{
  uiName = "Blimp - Scorpios";
};

datablock FlyingVehicleData(gc_BlimpCannonVehicle : gc_BlimpVehicle)
{
  uiName = "Blimp - Cannons";
};

function gc_BlimpScorpioVehicle::onadd(%this,%obj)
{
  %obj.playThread(0,"root");
  %obj.PlayAudio(0,gc_BlimpEngineSound);
  %obj.mountImage(gc_BlimpTrail7Image,0);
  %obj.mountImage(gc_BlimpTrail8Image,1);
  %t = new AIPlayer() { dataBlock = gc_ScorpioTurretPlayer; };
  MissionCleanup.add(%t);
  %obj.mountObject(%t,1);
  %obj.turret1 = %t;
  %t = new AIPlayer() { dataBlock = gc_ScorpioTurretPlayer; };
  MissionCleanup.add(%t);
  %obj.mountObject(%t,6);
  %obj.turret2 = %t;
}

function gc_BlimpCannonVehicle::onadd(%this,%obj)
{
  %obj.playThread(0,"root");
  %obj.PlayAudio(0,gc_BlimpEngineSound);
  %obj.mountImage(gc_BlimpTrail7Image,0);
  %obj.mountImage(gc_BlimpTrail8Image,1);
  %t = new AIPlayer() { dataBlock = gc_PCannonTurretPlayer; };
  MissionCleanup.add(%t);
  %obj.mountObject(%t,1);
  %obj.turret1 = %t;
  %t = new AIPlayer() { dataBlock = gc_PCannonTurretPlayer; };
  MissionCleanup.add(%t);
  %obj.mountObject(%t,6);
  %obj.turret2 = %t;
}

function gc_BlimpScorpioVehicle::onImpact(%this,%obj,%col,%pos,%speed1)
{
  %speed2 = vectorLen(%obj.getVelocity());
  %obj.damage(%obj,%obj.getPosition(),%speed);
  if(%obj.destroyed) return;
  if(%speed1 > 25 || %speed2 > 25)
  {
    %p = new Projectile()
    {
      dataBlock = vehicleExplosionProjectile;
      initialVelocity = 0;
      initialPosition = %obj.getTransform();
      sourceObject = %obj;
      client = %obj.client;
    };
    MissionCleanup.add(%p);
    %obj.setDamageLevel(%this.maxDamage);
    %obj.destroyed = 1;
    %obj.schedule(10,"finalExplosion");
    %respawn = %obj.spawnBrick.client.minigame.vehicleReSpawnTime;
    %obj.spawnBrick.schedule(%respawn,"spawnVehicle");
  }
}

function gc_BlimpCannonVehicle::onImpact(%this,%obj,%col,%pos,%speed1)
{
  %speed2 = vectorLen(%obj.getVelocity());
  %obj.damage(%obj,%obj.getPosition(),%speed);
  if(%obj.destroyed) return;
  if(%speed1 > 25 || %speed2 > 25)
  {
    %p = new Projectile()
    {
      dataBlock = vehicleExplosionProjectile;
      initialVelocity = 0;
      initialPosition = %obj.getTransform();
      sourceObject = %obj;
      client = %obj.client;
    };
    MissionCleanup.add(%p);
    %obj.setDamageLevel(%this.maxDamage);
    %obj.destroyed = 1;
    %obj.schedule(10,"finalExplosion");
    %respawn = %obj.spawnBrick.client.minigame.vehicleReSpawnTime;
    %obj.spawnBrick.schedule(%respawn,"spawnVehicle");
  }
}

function gc_BlimpScorpioVehicle::onRemove(%this,%obj)
{
  if(isObject(%obj.turret1)) %obj.turret1.delete();
  if(isObject(%obj.turret2)) %obj.turret2.delete();
}

function gc_BlimpCannonVehicle::onRemove(%this,%obj)
{
  if(isObject(%obj.turret1)) %obj.turret1.delete();
  if(isObject(%obj.turret2)) %obj.turret2.delete();
}
